#include <iostream>
#include "dialog.h"
#include "ui_dialog.h"

Dialog::Dialog(QWidget *parent)
    : QDialog(parent), ui(new Ui::Dialog)
{
    std::cout<<"calculating \n calculating \n calculating \n calculating \n ";
    ui->setupUi(this);

    connect(ui->lineEdit_estimate,SIGNAL(textEdited(QString)),this,SLOT(calculate()));
    connect(ui->lineEdit_bug,SIGNAL(textEdited(QString)),this,SLOT(calculate()));
    connect(ui->lineEdit_nobug,SIGNAL(textEdited(QString)),this,SLOT(calculate()));
    connect(ui->spinBox_success,SIGNAL(valueChanged(int)),this,SLOT(calculate()));
    connect(ui->spinBox_fail,SIGNAL(valueChanged(int)),this,SLOT(calculate()));

}

Dialog::~Dialog()
{
    delete ui;
}

float Dialog::calculateProb(double estimate,double pconn,double pnoconn,int repros,int nonrepros)
{
    double last =estimate;
    for (int i=0;i<repros;i++)
        last=last*pconn/(last*pconn+(1-last)*pnoconn);
    for (int i=0;i<nonrepros;i++)
        last=last*(1-pconn)/(1-(last*pconn+(1-last)*pnoconn));


    double last2=estimate;
    for (int i=0;i<nonrepros;i++)
        last2=last2*(1-pconn)/(1-(last2*pconn+(1-last2)*pnoconn));
    for (int i=0;i<repros;i++)
        last2=last2*pconn/(last2*pconn+(1-last2)*pnoconn);

    return (last+last2)/2;
}

bool Dialog::goodProb(double& prob)
{
    return (prob>=0 && prob<=1);
}

void Dialog::calculate()
{
    bool overall_ok=true;

    bool temp_ok=true;
    double estimate = ui->lineEdit_estimate->text().toDouble(&temp_ok);
    overall_ok |= temp_ok;

    double pbug = ui->lineEdit_bug->text().toDouble(&temp_ok);
    overall_ok|=temp_ok;

    double pnobug = ui->lineEdit_nobug->text().toDouble(&temp_ok);
    overall_ok|=temp_ok;

    int successes = ui->spinBox_success->value();
    int fails = ui->spinBox_fail->value();

    QString s;

    if (overall_ok && goodProb(estimate) && goodProb(pbug) && goodProb(pnobug))
    {

        float finalprob = calculateProb(estimate,pbug,pnobug,successes,fails);

        s.setNum(finalprob,'f',4);
        ui->lineEdit_finalprobability->setText(s);
    }
    else
    {
        s="N/A";
    }

    ui->lineEdit_finalprobability->setText(s);
}
